Package ghidra.pcode.emu.jit.analysis

# Class JitAnalysisContext

java.lang.Object
ghidra.pcode.emu.jit.analysis.JitAnalysisContext

public class JitAnalysisContext extends Object
A collection of state that is shared among several phases of the translation process.

See Also:
  - `JitCompiler`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `JitAnalysisContext(JitConfiguration config, JitPassage passage)`
  Construct a new context, starting with the given configuration and source passage

- ## Method Summary

  Modifier and Type
  Method
  Description
  `JitConfiguration`
  `getConfiguration()`
  Get the JIT compiler configuration
  `Endian`
  `getEndian()`
  Get the endianness of the translation source, i.e., emulation target.
  `String`
  `getErrorMessage(PcodeOp op)`
  Get the error message for a given p-code op
  `SleighLanguage`
  `getLanguage()`
  Get the translation source (i.e., emulation target) language
  `JitPassage.AddrCtx`
  `getOpEntry(PcodeOp op)`
  Check if the given p-code op is the first of an instruction.
  `JitPassage`
  `getPassage()`
  Get the source passage

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### JitAnalysisContext

    public JitAnalysisContext(JitConfiguration config, JitPassage passage)
    Construct a new context, starting with the given configuration and source passage
    Parameters:
      `config` - the JIT compiler's configuration
      `passage` - the passage selected for translation

- ## Method Details

  - ### getConfiguration

    public JitConfiguration getConfiguration()
    Get the JIT compiler configuration
    Returns:
      the configuration

  - ### getPassage

    public JitPassage getPassage()
    Get the source passage
    Returns:
      the passage

  - ### getLanguage

    public SleighLanguage getLanguage()
    Get the translation source (i.e., emulation target) language
    Returns:
      the language

  - ### getEndian

    public Endian getEndian()
    Get the endianness of the translation source, i.e., emulation target.
    Returns:
      the endianness

  - ### getOpEntry

    public JitPassage.AddrCtx getOpEntry(PcodeOp op)
    Check if the given p-code op is the first of an instruction.
    Parameters:
      `op` - the op to check
    Returns:
      the address-context pair
    See Also:
      - `JitPassage.getOpEntry(PcodeOp)`

  - ### getErrorMessage

    public String getErrorMessage(PcodeOp op)
    Get the error message for a given p-code op
    Parameters:
      `op` - the p-code op generating the error
    Returns:
      the message
    See Also:
      - `JitPassage.getErrorMessage(PcodeOp)`